#ifndef ICODE
#define ICODE

enum OpType {
  NULLOP,
  NUMBEROP,
  VAROP,
  STRINGCONSTOP,
  TEMPOP
};

enum OpCode {
  ADDOP,
  ANDOP,
  CALLOP,
  DIVIDEOP,
  INPUTOP,
  JUMPOP,
  JUMPGEOP,
  JUMPLEOP,
  MINUSOP,
  MULTOP,
  NOTOP,
  OROP,
  PRINTOP,
  RETURNOP,
  STOREOP,
  NUMOPCODES
};

struct Operand {
  OpType opType;
  union {
    unsigned short tempValue;
    double number;
    unsigned int dataAddress;  /* string const or var name */
  } opValue;
};

struct Tuple {
  OpCode opCode;
  Operand op1;
  Operand op2;
  Operand res;
};

#endif
